Welcome

Welcome to Fractal Forge

Copyright © 1996-2002 Uberto Barbini


Index

Fractal Forge v2.7.2

Introduction
 License agreement
New and future features
Hardware requirements
How to install & uninstall
Menu choices
Main Parameters
How fast is Fractal Forge?

Reference Section

Tutorial
Drawing & Zooming
Operations with Colors
Iterations & Bailout
Julia Mode
Additional Features
Potential
Saving Files
Filters
Fractals on the web

Acknowledgments
How to Contribute Feedback


Introduction

Minibrot Introduction

Fractal Forge was born the day I had to print several fractal images and some simple posters with an Epson Stylus color printer. Back then, I realized there was no true color fractal generator for MS-Windows in the shareware market, so I decided to program one myself. I called it UbiMandel (after my name), and I wrote it in Visual Basic 3. I did not optimize the first version's algorithm because I didn't need to. Once I bought Delphi, I wondered what * simple program I could do, so I began to code True Mandel, another fractal program. I started it in May 1995 and finished it the following October. I released it on the Internet as True Mandel 1.0 (trmand10.zip), which stands for True Color Mandelbrot Set Generator.

Later, I decided to migrate to the win32-bit world (NT and 95-98) using Delphi 2. Soon, there were two shareware versions of TrueMandel: 1.5 and 1.6. In 1999, I completely rewrote the program in Delphi 4, and changed its name to Fractal Forge because there were several applications with similar names already available.

Since version 2.4 I decided to make Fractal Forge open source, so I published it to http://sourceforge.net/projects/fractalforge. I have less and less time to improve Fractal Forge so I hope someone else can continue its growing.

Your feedback was--an still is--very appreciated... I have received dozens of letters, both email and on paper. Keep writing to me, and I will keep developing this program.

If you are the author of any shareware program, I'll be glad to exchange sources or user licenses. If you need the source code for improving the program, visit Fractal Forge's web site at SourceForge or contact me by email at uberto@ubiland.net.


Licence Agreement

Fractal Forge is an Open Source program. You may use it on as many computers as you want. Postcards and/or e-mails with suggestions or compliments are always welcome. You can also get the source and modify it, as far as you include the reame.txt file and don't modify this licence. If you use Fractal Forge generated images you must acknowledge it.

Postcards and/or e-mails with suggestions or compliments are always welcome.

Please contact the author (by email) to include this program in large distribution as in newspapers, CD-ROMs, and floppies, OR send him a copy of the final distribution.

Copyright ©1996-2002 Uberto Barbini

FOR PROGRAMMERS: If you have a programming question, please contact me at SourceForge or at Marco Cantu newsgroups and (dedonline.com).

FOR ENGLISH MOTHER-TONGUE: I need help to finish this help file. Please, contact me at SourceForge if you want to contribute with this. I would really appreciate it.

PER ITALIANI: Fatemi sapere se ci sono volontari per la traduzione italiana di Fractal Forge.

PARA ESPAÑOL: Si alguna persona de habla española estaría interesada en hacer la traducción de este archivo de ayuda, déjemelo saber.

ANY OTHER LANGUAGE: If you speak any other language and would like to translate this help file, please contact me at SourceForge.

Refer to the readme.txt files for additional information.


New Features

Current version 2.7.2, April 2002

Improvements over FractalForge 2.7.1:

  • New help file.
  • Fixed a nasty bug in Equalize Colors.
  • Fixed a bug opening the help file.
  • Improved Edge and Bumper filters.
  • Additional minor bug fixes.

Improvements over FractalForge 2.7.0:

  • Fixed a bug in import MAP filter.
  • Add two Paste Params buttons in animator dialog.

Improvements since Fractal Forge 2.6:

  • Removed the to do list, it's obsolete
  • More responsiveness during long fractals (iter > 1M).

Improvements since Fractal Forge 2.6 prerelease:

  • Lots of bugfixes.
  • More responsiveness during long fractals (iter > 1M).
  • Pressing Enter in Comments field doesn't start another fractal.
  • Shows percent in application caption.
  • Orbits in shades (black to white) with mandel in background.
  • Orbits window shows up to 10000 values.
  • Press Esc to stop drawing the current fractals.
  • Finished translating source.
  • Fixed some flickering around.
  • Added two new filters.
  • Filters are applied after calculations.
  • Opening of old files.
  • Recompiled under Delphi 6.
  • Removed forge background for flickering.
  • Removed htmlhelp.ocx references for some incompatibility.
  • Added File|New choice, same as Fractal|Start

Improvements since Fractal Forge 2.4 beta4:

  • Added a feature to transform a sequence of BMP files into a single AVI file.
  • Added Tools menu.
  • Moved Poster composition to Tools menu.
  • Added Animator tool for making animations from BMP files.
  • Added a feature to copy coordinates to the clipboard.
  • Fixed a bug that prevented saving the *.ini file.
  • Fixed a bug with elapsed time.

Improvements since Fractal Forge 2.3:

  • Added JPG saving capability.
  • Changed "iteractions" with "iterations".
  • Changed "Iter" with "Value" on bottom right corner. It shows current value (e.g. potential, if you choose it) of image point, not always Iteration.
  • Upgraded to Delphi 5.
  • Added Julia Floating window.
  • Fixed a bug in Poster Options (when the images are not square).
  • Fixed a bug in Orbits Algo.

Improvements since Fractal Forge 2.2:

  • Added new Full Screen mode (Option menu).
  • Added a new color (Nature).
  • Added a new image (Elephant).
  • Fixed a bug in replacing a file color.
  • Caption bar displays current fractal name.
  • Added Author and Image informations in PNGs.
  • It's now possible to drag a file onto Fractal Forge to render it immediately.
  • Added another image dimension (500 x 500).
  • Fixed some bugs in History List.
  • Added State and Version in History List. Crono and Time are now separated.
  • Fixed a major bug in Load/Save Lists.
  • Allow quitting when drawing a fractal.
  • Correct progress bar position during Bounds drawing.
  • It's possible to reset Starting Values (by pressing cancel button).
  • A few a minor bugs fixed.

Improvements since True Mandel 1.6:

  • Color Editing.
  • Improved and faster algorithms.
  • Better user interface.
  • Simpler and more powerful zooms.
  • Improved printing.
  • Poster images.
  • Filters.
  • Png Support.
  • Exe packed.
  • A lot of minor bugs fixed.

Improvements since True Mandel 1.5

  • 32 bit optimized code.
  • 80 bit precision (21 digits).
  • Max iterations over 2*10^9.
  • Win95 components support.
  • Win95 long file name support.
  • Percent of drawing showed on title (also when minimized).
  • Info on toolbox about the point you are on.
  • Preview color spectrum and current image.
  • New faster image display.
  • New draft mode (no second pass).
  • Faster 'None' optimization (but still exact).
  • New moveable rectangular zoom.
  • More bugs fixes.


Hardware Requirements

You need a x486 (actually, x386 + x387 works too) or better and Microsoft Windows 9x, NT or later (including Win2000 and XP).

A big amount of RAM memory improves speed. I recommend al least 32Mb. More if you like huge fractals.

Fractal Forge doesn't need a true color graphics card, but I strongly recommend it. True color means over 16 million colors (2^ 24). However, if you have a 256-color video card, you can select Draft from Optimization to have a dithered image.

With most Windows 9x video cards, you can just right click on the desktop to change the number of colors.


How to Install & Uninstall

Simply unzip all the files into a new directory. I hate installation routines, so I avoid them as much as possible.

To uninstall, simply delete Fractal Forge's directory (and subdirectories). Fractal Forge does not add anything to the Windows directory. For a complete uninstall you can delete this key from Registry: HKEY_CLASSES_ROOT\FractalForge.Files if you don't how do it, don't worry, there is not problem to leave it there.

If you have a previous version of Fractal Forge or True Mandel, you can delete all the files--except images (*.mnd, *.bmp)--and then copy the new files. Fractal Forge can open old *.mnd files, but will eventually save them in a slightly different format. Thus, you won't be able to open them in an older version anymore.

Fractal Forge will associate itself with extensions (*.mnd, *.mnl) automatically at first run. Then, you will be able to start Fractal Forge simply by double clicking on a fractal file.


Menu Choices

File

NEW
 Reset parameters and begins a new image.

OPEN FILE
 You can see a list of all the fractals saved, select one of them and open the file. Fractal Forge comes with several fractal files containing the image and its parameters. You can also open old True Mandel files.

SAVE FILE
You can save the parameters only. The parameters file is 1023 bytes in size.

SAVE IMAGE
You can save the image only, and open it later with other programs to print and adjust it. Now Fractal Forge supports JPG, PNG and BMP formats. BMP image size can be pre-calculated, by multiplying width by height by 3 (w x h x 3 - because it's 3 bytes for each pixel). So a 640 x 480 image occupies 921 600 bytes on disk. PNGs are a lot of smaller because they are compressed, so I strongly recommend the use of PNG format instead. PNG format allows the insertion of some additional information as author, title and description. You can see them with a PNG editor (Paint Shop Pro, for example). JPG files are further compressed and you may notice some loss of quality.

SAVE TO DESKTOP
Save images to the Windows directory and choose it as desktop background. If you have select Active Desktop you must disabled it to see the image.

ADD LIST
You can open a file containing a list of fractals. The corresponding fractals will be added to the HISTORY LIST. You can import a single file too (useful to read parameters without drawing the image), for example, to check the execution time.

SAVE LIST
You can save your current history list.

PRINTER SETUP
Standard Windows printer setup dialog box.

PRINT
Prints the current image together with its main parameter values.

EXIT
Exits the program.

Edit

PREVIOUS FRACTAL
Redraws the previous fractal.

COPY IMAGE
Copies the image to the clipboard.

COPY VALUES ONLY
Copies parameters to the clipboard as text.

Fractal

START
Starts drawing.

PAUSE
Suspends drawing. Click again to resume drawing.

IMAGE (same as right-clicking the image)

ZOOM IN
To select a rectangular area of the fractal and enlarge it from its center.

ZOOM OUT
To reduce the fractal appearing on display by 4 times (or more if you drag the cursor).

FREE ZOOM
To select a rectangular area and customize it by dragging the corners or moving the borders (cancel it by clicking out).

SHOW ORBITS
Shows the escape path (orbit) of current pixel in a floating window.

SHOW GRIDS
Shows the position at a given iteration of 25 near pixels in a floating window.

SHOW JULIA
Shows a preview of the Julia set corresponding to the cursor position in the Mandelbrot set.

COPY COORDINATES
This must be selected from the right mouse click. It copies the coordinates to the clipboard.

AREA
Shows statistical data of the current image.

Filters

Various filters made by current image values. NONE (first option) returns the image to its original state.

Options

FULL SCREEN MODE
Enter or leave full screen mode. In FULL SCREEN MODE the menu and control panel become visible when the mouse is near the top or to the right border of the screen, respectively.

SHOW CONTROL PANEL
Shows or hides the PARAMETERS panel.

SAVE FILE IN 8.3 FORMAT
Saves the file in old DOS format by default.

RESTORE OLD VALUES
You can select a fractal from the drop down list of LIST and restore it on your display.

DEFAULT VALUES
Restores the default fractal.

SELECT STARTING VALUES
Lets you choose a starting image.

EDIT COLORS
Lets you create new color sequence or edit the existing ones.

TEST FLOATING POINT SPEED
How fast is my computer? My old Pentium 100 marks 2,863,000 iterations per second (16-bit version was 2.336.000). Then, my Celeron 450 marks 11,268,731. Every iteration makes 6 floating-point additions and 3 floating-point multiplication. Now, it marks 27.5 million iterations on a Pentium III 667MHz, and 77.5 millions on a Athlon 1 333MHz (1.3GHz).

Tools

Animator
Creates an animated sequence of pictures. Now you have two buttons to use fractal paramaters copied into clipboard with Ctrl+P.

POSTER COMPOSITOR
Enables you to save the current image in a tiled set of small images for huge pictures.


Main Parameters

BAILOUT
It is quite a technical parameter; it determines the limit at which iteration escapes to infinity. For the Mandelbrot Set it has to be equal to or greater than 4. Higher values will produce smoother bands.

COLOR BY
Lets you choose how to use colors; ITERACTIONS or POTENTIAL (slower and cooler) are usual. Try them all!

FORMULA
Instead of the classic Mandelbrot formula, you can try some more. Some other programs let you write to your own formulas; that can be useful for researchers, but it slows everything down. So I'm waiting for some guy to help me with a Just in Time Compiler for formula.

JULIA and PERTURBATION
These are options for Julia sets fractals, a whole family closely related to the Mandelbrot Set. Briefly: every point in the Mandelbrot Set generates a different Julia set. Visually, you can notice the association. If the point belongs to the Mandelbrot Set, the Julia Set will be "connected", otherwise it will be "disconnected". Once you choose a good point, check JULIA MODE and START to see it. Usually you will have to lower the MAGNIFICATION to 0.4 to see it all. See Reference Section for more.

RECT COORDINATES
Lets you to use coordinates of 4-image corner. I use it to compare images among different fractal applications.

DRAWING ALGORITHM
There are several drawing algorithms. BOUNDS is pretty good, but you could prefer DRAFT for low resolution (faster) image computing or BOUNDSMP if you have a multi-processor system. INTERPOLATE generates less precise images but generally it's faster than BOUNDS.

OFFSET
Lets you animate colors. It doesn't use a palette as 256-color programs do, so the redrawing is slower.

LIST
Shows a list of names of the images you have done. Select one of them to see all its parameter values. If you change the name of the last fractal, you have to reselect it to read a new name.


How Fast is Fractal Forge?

I wrote this when I released True Mandel 1.6:

It's very difficult to understand the speed of a fractal program. I evaluated a lot of programs both for Windows and for Mac. Most are very fast because they use very poor precision algorithms. Besides they don't always show all the parameters you need to compare the drawings among them.

Another problem is the kind of optimization; I know three types. First there are "adjacent colors based" algorithms. They can greatly decrease execution time when large spots of a single color characterize the images. True Mandel uses two algorithms of this kind. You can choose them from optimization combobox. Normal is a good choice (I think it's the same as FractInt), Turbo is faster but it lacks in precision, especially where nearly round areas touch.

The second kind is based on the behavior of the iteration coordinates. It's worth it for a very high iteration value only (greater than 1000). I didn't include it because it doesn't work in most cases, and is slow in others.

The third type is based on pre-calculated zones. It consists in checking if every point lies in an area mathematically defined as belonging to Mandelbrot Set. Another similar algorithm is based on the symmetry of Real axis of the Mandelbrot Set. I didn't include any of them because they speed up only low magnified images or special zones.

You can also improve calculation code for a specific processor (I worked a lot on Pentium). But every month someone announces a new wonderful fractal algorithm...

Fractal Witchcraft uses a very interesting new algorithm (synchronous orbits) that in some cases improve speed from 10 to 100 times... I'll try to implement it in future versions. However I'm looking for a parallel multi-tasking algorithm to use all Windows NT features. Can you imagine fractal generation on a four 200 MHz Pentium Pro system? (The fastest PC you that can buy at the moment).

My computer is a Pentium 100Mhz with 16 Mb ram chipset Triton, 256k writeback cache, Advance Logic 2302 video card with a 1 Mb Dram PCI, hard disk WD Caviar 850Mb. I tested WinFract 18.21 FractInt 19.2 and Fractal Witchcraft (rumored as the fastest fractal program) with these values:

Dimension: 640 x 480 pixel

Ora 53" con Bounds nota + dell'incremento matematico

Min - max X (real part): -1.16235 -1.16227
Min - max Y (imaginary): 0.22726 0.22732
Iterations: 10000

WinFract 18.21 (floating point and 16bit values on, other parameters as default) 7' 29".
FractInt 19.2 (floating point on, other parameters as default) 6' 22".

Fractal Witchcraft (edge on, warp on) 5' 01".
Fractal Witchcraft (edge on, warp off) 8' 08".
Fractal Witchcraft (edge off, warp off) 10' 28" (Warp on decrease precision).
True Mandel 1.5 (priority High, optimization Normal) 5' 00".
True Mandel 1.5 (priority Very high, optimization Turbo) 3' 54".
True Mandel 1.6 (priority High, optimization Normal) 4' 06".
True Mandel 1.6 (priority Very high, optimizationTurbo) 3' 14".
Dimension: 640 x 480 pixel
Min - max X (real part): -0.5510313972380302 -0.55103139721913384
Min - max Y (imaginary): 0.6271333416120786 0.6271333415748123
Iterations: 12000

FractInt 19.2 (floating point on, other parameters as default) 6' 10".
Fractal Witchcraft (edge on, warp on) 1' 07".
Fractal Witchcraft (edge on, warp off) 1' 21".
True Mandel 1.5 (priority High, optimization None) 5' 16".
True Mandel 1.6 (priority High, optimization None) 4' 31".
True Mandel is the fastest now! It's due to 32 bits code and Pentium optimization fpu routines.
But in some cases Fractal Witchcraft seems fly...
Note that Fractal Witchcraft edge detection method doesn't reduce precision.
Note also that 24 bit graphics is slower than 8 bit...

Now (December 1999) the situation is very similar. Fractal Witchcraft has been abandoned and no other program uses its algorithm. Anyway, it seems to be better in only a few cases. The best fractal program right now seems to be UltraFractal (www.ultrafractal.com), but I still think Fractal Forge is easier to use.

I didn't do very detailed tests, but Fractal Forge appears to be a little faster than UltraFractal (on similar conditions), and significantly faster than any other fractal program. Anyway, UltraFractal is by far more powerful and customizable than Fractal Forge.

And Fractal Forge is freeware ;-)


Tutorial

If you want to know more about the magical word of fractals, follow my instructions:

  • Expand the zip file into a new directory.
  • Open Fractal Forge and maximize it for a better view.
  • Press START. You will see MAND002 color STANDARD, which is the whole Mandelbrot Set.
  • Observe the calculation status on the upper right corner and you will know the executing time of your PC and the percentage of execution. Once DONE appears, your image is finished.
  • If you want to know more about the mathematical side of fractals, you can find a lot of very good information on the Internet. Also, there are a lot of good books on the subject. For a brief introduction, see the Reference Section.

The DATA tab on the PARAMETERS panel shows the center's location with respect to the system of axes (see REAL PART and IMAGINARY PART) and the precision degree (see ITERATIONS). Now let's modify these parameters:

  • Click on -0.75 REAL PART OF CENTER, write 0, and press START. Notice the center's displacement.
  • Click on 0 IMAGINARY PART OF CENTER, write 1, and press START. Again, notice the center's displacement.
  • Click on 100 ITERACTIONS, write 1000, and press START. Notice the variation from the original. More iterations means more precision, but also more time to finish an image.

Let's examine particular portions of the whole. To do so, you can use the buttons on the right side, right click on the image or use the menu: Fractal>Image.

  • Press ZOOM IN, and move the lens over the fractal. You can select a square portion and enlarge it by dragging the lens and then releasing the mouse button. Re-iterate the enlargement successively and observe the results.
  • Press ZOOM OUT and move the lens over the fractal. Now, you can reduce the image by dragging the lens and then releasing the mouse button.
  • Press FREE ZOOM and move the lens over the fractal. You can select a rectangular area by dragging the lens and then releasing the mouse button. You can edit it directly by dragging the corners, dragging the borders (where the cursor becomes a cross) or cancel it selecting another zoom. To enlarge it, just click in the middle.

Using the lens tool you can explore your fractal, and obtain many evocative images. You can save your favorite ones pressing FILE>SAVE IMAGE. With this function, you will only save the image; the mathematical data will be lost so you will not be able to recalculate the same fractal later. However you can view the saved image with an image editor (Paint Shop Pro, for example).

FILE>SAVE FILE will save the data, allowing you to recalculate the same fractal later. Fractal Forge is provided with some interesting images. Press FILE>OPEN FILE, look in the dialogue box and you will see a list of available fractals. For example: select BRAIN, press OPEN and watch the result.

Of course, by doing the above, it is possible to change IMAGE MAIN PARAMETERS and to ZOOM IN and ZOOM OUT. You can also resave the fractal. Let's try again.

  • Press FILE>OPEN FILE, and select FLAG. Choose FULL SCREEN MODE from the Option menu. To use the menu while on FULL SCREEN MODE move the mouse to the top of the screen; to see the parameters move it to the right.
  • Set WIDTH and HEIGHT according to your screen resolution and then press START to render it.
  • Now, zoom in and find another interesting portion of the fractal. Change the REAL PART and IMAGINARY PART values and save the image using FILE>SAVE FILE.

Now we're going to examine some more details about DATA PARAMETERS. TITLE suggests a progressively numbered name for the fractal. If you prefer, you can give it a new name up to 32 characters long. The name will be saved together with other parameters. Let's try it.

  • Open the file STARTING, increase ITERATIONS to 150 and press START to redraw. Now select the suggested title and substitute it with BOILED POTATO. This will be the new name of your fractal (choosing FILE>SAVE FILE).

MAGNIFICATION shows the fractal's degree of enlargement. It's calculated on the Y-axis, i.e. if Imaginary bounds are 0 and 0.5, the magnification will be equal to 2 regardless of Real bounds. (Try it by setting Imaginary part of center to 0.25 and Magnification to 2. Then move the cursor from the top of the image down to the bottom. You'll see the Imag value—at the bottom of the panel—go from 0.5 to 0). The starting value of Magnification is 0.4 but you can increase or decrease it at will.

  • Click on DEFAULT in the HISTORY LIST tab to return to the default image. Now click the Data tab and select MAGNIFICATION 0.4 and change it to 0.1. Press START and look at the new image.
  • Set COLOR BY to equal POTENTIAL and START for a smooth image. Then go to IMAGE PARAMETERS and choose image size and colors.
  • Check on PREVIEW and change COLOR SEQUENCE to your personal favorite color method. If you think you can do better, press EDIT COLORS to create your own sequence.

Once you have created a new wonderful image you will surely want to print it onto every wall of your room! ;-) No problem. Just click on TOOLS>POSTER COMPOSITOR and Fractal Forge will enlarge and divide it automatically into several smaller images (you can choose how many you want). Print them all using a color printer, and with a scissors and glue you can create a wall-size fractal.

Now, you can go on exploring by yourself.


Drawing and Zooming

Fractal Forge opens up with a basic image. To zoom and draw, use the menu at the top of the screen:
Fractal >
Image >
Free Zoom.

Alternatively, you can click on the toolbar icons to perform the same operations. The first icon equals ZOOM IN from the drop-down menu; the second one, ZOOM OUT, and the third one FREE ZOOM.

Zoom InZoom OutFree ZoomStart calculating the image
Move the mouse over
each icon to get its function.

Choose FREE ZOOM either way, and the cursor will change to a magnifier with a small cross at the upper left corner (somewhat similar to the first toolbar icon). Drag the cursor in any direction to draw a box marking the zooming area.

The box shows four little squares in each corner. When you move the cursor over any of these squares, it turns into a directional arrow. When it does so, you can resize the box by pressing the left mouse button and dragging the cursor. Clicking once inside the box will zoom in that region.

You can also move the zooming area (the box) when using FREE ZOOM. To do this, just move the cursor to any of sides of the box, and it will turn into two biheaded crossing arrows. When it does so, you can press and hold the left mouse button and drag the box anywhere you want.

Drawing a box with either the ZOOM IN or ZOOM OUT options will do almost the same function, with the distinction that releasing the mouse button will automatically zoom in (or out) the selected portion. That area will become your new image, so be careful. In any case, you can undo any changes by using the PREVIOUS FRACTAL option under the EDIT menu.

You can bypass or undo several changes at the same time. Fractal Forge automatically keeps a history of all the changes you have made to an image while you're working on it under the HISTORY LIST tab. Using the PREVIOUS or RESTORE commands, you can return to any recorded state in the drop-down list. Each image's history list will remain available until you close it. Once closed, the History list will be erased.


Color Map Modification

Editing the colors

In the right hand panel, click the IMAGE tab.

Select a color map from the COLOR SEQUENCE drop-down box.

Edit the color map or create a new one by clicking the EDIT COLORS tab.

Choose...

Distribution: Direct
Application: Linear
Method: HSL or RGB

as show in the figure below. There are some additional options to choose from each drop-down menu.

In this window, you'll find a set of ribbons labeled 1, 2,... and LAST. On each ribbon, there is a square box at the left and right sides.

The ribbons define how the colors are mapped across the m values, from 0 to the max of iterations (n-max). Ribbon 1 is at the zero end, while ribbon LAST is the n-max end.

The ADD COLOR button at the top allows you to start with 1 ribbon, adding more ribbons until m have been reached. m = 8 works well (but hundreds of ribbons are possible).

The range of n is divided by going sequentially through the ribbons:

ribbon 1 left box, ribbon 1 right box
ribbon 2 left box, ribbon 2 right box
...
ribbon m left box, ribbon m right box.

(Last is no longer used in the latest release of Fractal Forge. It used to be the color for the highest value of Iterations; now the color of the right hand end of the highest numbered ribbon is used instead).

Define a color for the left box of any ribbon by left clicking on the box and then choosing a color. You can also do this by dragging a color from another ribbon box.

Define the color at the right box of a ribbon in the same way or by using the right mouse click. This operation opens up a pop-up menu with several options:

Equal previous: sets the right end color to the same color of the left box for the ribbon
Equal next: sets right end to same as left end of next ribbon
Equal all previous: sets right end to same as left end of same ribbon, for all ribbons
Equal all next: sets right end to same as left end of next ribbon, for all ribbons.

Any color can be removed by pressing the REMOVE COLOR buttom found at the top.

The color map creation/modification process can be automated by right clicking over any left end color and choosing RANDOMIZE ALL from the pop-up menu. This will change all ribbon colors to a random palette. The results can be modified following the same procedure described above.

Fractal Forge can also import FractInt color maps from this same EDIT COLORS window.

Applying and Saving colors

Once you're happy with your colors, make sure to save your changes (either to the same color map or to a new one).

Save and apply:
Saves the altered color map using the same filename overwriting the original information, and then applies the new color mapping to the open Image file. This command doesn't change the image or mandelbrot parameter files automatically, so you have to save them if you want to record those changes. To apply the color permanently, save the image or mandelbrot file from the file menu at top of screen.

If an existing map is selected from the drop down menu, Save and apply will apply that mapping to the open Image file.

Save file as:
Saves the altered color map to a new file (choose a new filename for it).


Iterations & Bailout

This section introduces a little of the math "behind the scenes" in Fractal Forge. For further mathematical details, it would be better to consult a good book on the subject!

The program iterates the relation Zn+1 = Zn2 + C, where Zn is a complex variable and C = xi + y is in the complex plane.

This is often described as iterating the mapping: Z becomes f(Z) = Z2 + C or Z ->Z2 + C, or the rather mathematically lax Z = Z2 + c.

It does this for every value of C corresponding to each pixel on the screen, starting at Z0 = 0.

The image size is found under the IMAGE tab on the right panel. It determines the number of pixels that will be calculated for the current picture. Choose a size according to the screen size (e.g. 640x480) for best results (for even better results, calculate it some two or three times larger than the final image resolution, and apply an anti-alias command afterwards to get a smaller size version with finer details). You can also go to OPTIONS > FULL SCREEN MODE (see the Menu Commands section for additional information).

If Z stays finite after a maximum number of iterations, C is in the Mandelbrot set. More specifically, it compares Zn with the chosen bailout value.

The iIterating process continues until either:

(a) the value of |Zn| > bailout after n iterations (when a color is plotted for the pixel—which is at C = xi + y—depending on n), or

(b) the maximum value specified for n is reached and |Zn| has not reached the bailout. In that case the color specified for the maximum value of n is used. (See Operations on Colors).

Choose the maximum value for ITERATIONS (n) and BAILOUT from the menus on the right panel. They are under the DATA tab. Iteration 500 and bailout 128 work well in most cases.

This explanation assumes COLOR BY: Iterations (under the same tab, immediately below BAILOUT) has been selected.


Julia Mode

Some of the most fabulously beautiful images come from Julia mode. It is found under the DATA tab in the right panel. To use this method, open a mandelbrot starting file. Reduce the image size to 320x240 (that size yields faster calculations and shows the whole symmetrical image).

Zoom in on any portion you want the Julia for, but DO NOT click JULIA yet. For Julia fractals, ZOOM IN is better than FREE ZOOM (refer to Drawing and Zooming) free zoom because the cross stays on the center of the zoom area and Julias are symmetrical.

Zoom in somewhere again. Repeat the process until the center of the cross (the cursor) gives you the value of C for which the Julia set is desired. Then, in the DATA tab, check on JULIA. The value of point C will automatically appear in PERTURBATION (both real and imaginary parts). Then, reduce the magnification value to 0.4 or less by overtyping what shows in the space provided, and click START. From then on you can zoom in while staying in Julia mode, examining parts of that Julia set.

If you select JULIA too early (while the whole Mandelbrot set is visible on the screen), you cannot accurately place the value of C and may never get an interesting Julia. That is because the shape of a Julia set fractal is very sensitive to the value of C, so you need a reasonable level of magnification to position this value accurately.

Note while still in Mandelbrot mode, you can use the floating Julia Window to get a basic idea of the shape of the Julia set you will get. To display this window, from the Fractal menu, select IMAGE and choose SHOW JULIA.

As you move around the Mandelbrot set, the Julia window displays a preview of the corresponding Julia set. This floating window shows you the Julia Set corresponding to the current point under the cursor. There is a different Julia Set for each point of the complex plane. If the point belongs to the MandelBrot Set, then the resulting Julia Set will be connected; otherwise it will be sparse. Julia Sets are colored with FractalForge current color sequence.


Additional Features

Orbits Window

Orbits Window This floating window shows you the escaping path (or the orbit) of the current point. That is, you can see over a Mandelbrot set outline the sequence of iterating steps. You can choose between joining the points with a line or not. Points are initially black and later start to turn white.

You will find this command under the FRACTAL > IMAGE menu.

Rect Window

Rect Window Imagine you iterate 16 points at a time instead of only one. This floating window shows you their respective positions at a given iteration. At some point, increasing the iteractionsthe grid degenerates. It is possible to use this information to improve speed in some particular cases.


Potential

To view potential lines, use a color scheme that varies rapidly. "Spectrum stripes" color scheme varies linearly and so, like contours, each color change represents a fixed change of potential. "Spectrum stripes log" varies logarithmically. This means that changes of color depend on the ratio of potential, not the absolute value. Therefore it is good for showing equipotentials, which vary slowly far from the boundary of the set and quickly closer to the boundary.

It is interesting to use a low magnification (say 0.1) and very low iterations: 2,4,8,16, etc. Then gradually increase magnification.


Saving Files & Images

Saving Files and Images

To save the current Mandelbrot file so that Fractal Forge can open it again, go to the FILE menu at top of screen and select SAVE FILE.

To save an image for viewing on any image viewer or graphics editor, such as Paint Shop Pro or ACDSee, select SAVE IMAGE and pick PNG from the FILE TYPE drop-down menu. PNG files give quality as good as that of BMP files, but take only a fifth of the disk space. A 1024x768 BMP is about 2.5 megabytes. A PNG one is just 500k.

If you need an application to browse and view your Fractal Forge generated images, Irfanview (available from http://www.irfanview.com) is an excellent alternative.


Fractals on the Web

There are two web sites you can visit to get Fractal Forge information:

  • SourceForge
    This is the main site, where you will find the latest updates and source code.
  • Fractal Forge Web site
    This web site also keeps an up-to-date place to look for information and downloads for Factal Forge, plus some additional information, screenshots and other related web resources. Hosted by third.apex.to.fractovia.

There are many people using Fractal Forge to create interesting fractal images. To see some examples visit third.apex.to.fractovia.

There are a lot of wonderful sites regarding fractals on the web. These are some good starting points:

  • The Infinite Fractal Loop
  • spanky.triumf.ca
  • Cygnus Software
  • Ultra Fractal Web site


Acknowledgments

Acknowledgment
  • Juan Luis Martínez helped me to make this wonderful help file.
  • Stephen Rogers prepared the draft text that formed the base to this updated help file.
  • Brandon Waring helped me to correct the text for the v2.3 help file (and my English too!).
  • Cosimo Laddomada helped me with formulas for complex exponents.
  • Michael R. Ganss is working of synchronous orbits algorithms. I hope it'll be include in future versions.
  • Eric Engler helped me with png support.
  • I used Eric Grange (egrange@hotmail.com) code to use html help api from Delphi.
  • I checked source versions with Beyond Compare. Please visit www.scootersoftware.com.
    I used Eric Engler compiled dll for PNG. For Png support in Delphi and other info please visit www.geocities.com/SiliconValley/Network/2114/
  • sourceforge.org


How to Contribute

Minibrot How to Contribute

Besides for bug fixes, I consider Fractal Forge quite mature now, so I have no plans to release another version.

If you want me to keep working on this project or want to "sponsorize" aditional features, I haev a DVD wishlist at amazon.com, from where you can choose a gift for me. If you have no account on Amazon you can surely use another store! ;)


Feedback & Bugs Report

You can send snail mail or postcards to:

Uberto Barbini
Cannaregio 517
Venezia - 30121 - Italy.

If you have email access you can send a message to uberto@ubiland.net

If you have a programming question, please contact Uberto Barbini at Marco Cantu newsgroups. If you don't know them yet, go to www.marcocantu.com for information.

To report bugs and wished features, please use the Sourceforge system to send any email to me reporting your problem or idea.


Filters

Filters work after generating the image, using both real-fractal values and renderized colors. Because of that, they can accomplish some nice effects that are beyond the capabilities of external graphic editors such as Adobe PhotoShop or The Gimp. They have no matematical value; they are there for eyes pleasure only.

Here is a brief description of each filter:

  • None
    Returns the image to its original appearance.
  • Equalize color
    Redistributes colors from the minimum to the maximum values. Try it with high zoom factors.
  • Edge
    Darkens the points according to the difference between adjacent ones.
  • Lines
    Similar to Crystal (read next) but less selective. Try it with Color by=Iterations.
  • Crystals
    Shows only the points with values different to all the adjacent ones. Try it with Color by=Iterations.
  • Bumper:
    Produces and engraving effect.
  • Heights
    Similar to Color bumper (read below) but less dramatic.
  • Random noise
    Add noise varing randomly the luminance to a third of image values.
  • Color bumper
    Same effect as Bumper, but uses colors instead of luminance.
  • Sharpen edges
    Enhances the edges comparing to the average of adjacent values.